//------------------------------------------------------------------------------
// blocks.h
//------------------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
// 02110-1301, USA.
//
//------------------------------------------------------------------------------
// Copyright (C) 2010 "Blzut3" <admin@maniacsvault.net>
//------------------------------------------------------------------------------

#ifndef __BLOCKS_H__
#define __BLOCKS_H__

#include <ostream>
#include <stdint.h>

class Response
{
	public:
		Response();

		int32_t		giveID;
		int32_t		costID[3];
		int32_t		costAmount[3];
		char		response[33];
		char		yesMessage[81];
		int32_t		link;
		uint32_t	log;
		char		noMessage[81];

		void		Read(const char* buffer);
		void		Save(std::ostream &out) const;
};

class Speech
{
	public:
		Speech();

		uint32_t	speakerID;
		int32_t		dropID;
		int32_t		checkID[3];
		int32_t		link;
		char		name[17];
		char		sound[9];
		char		backdrop[9];
		char		dialog[321];
		Response	responses[5];

		// Old format
		uint32_t	voiceNumber;

		void		Read(const char* buffer, bool oldFormat);
		void		Save(std::ostream &out, bool oldFormat) const;
};

#endif /* __BLOCKS_H__ */
